<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Izg 2018 - 2019, lab 6.: První úkol</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">Izg 2018 - 2019, lab 6.
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="examples.html"><span>Examples</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">První úkol<div class="ingroups"><a class="el" href="group__init.html">Inicializace</a> &#124; <a class="el" href="group__draw.html">Kreslení</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<dl class="todo"><dt><b><a class="el" href="todo.html#_todo000004">Todo:</a></b></dt><dd>1.1.) Doprogramujte inicializační funkci <a class="el" href="student_8h.html#ac2adb2ba4e748239b9db4d037584d3cc" title="This function is called at start of application. It should contain initialization of CPU side...">phong_onInit()</a>. Zde byste měli vytvořit buffery na GPU, nahrát data do bufferů, vytvořit vertex arrays object a správně jej nakonfigurovat. Do bufferů nahrajte vrcholy králička (pozice, normály) a indexy na vrcholy ze souboru <a class="el" href="model_8h.html" title="This file contains a 3D model in static arrays. ">model.h</a>. Využijte proměnné ve struktuře <a class="el" href="structPhongVariables.html" title="This structure contains all global variables for this method. ">PhongVariables</a> (vbo, ebo, vao). Do proměnné phong.vbo zapište id bufferu obsahující vertex atributy. Do proměnné phong.ebo zapište id bufferu obsahující indexy na vrcholy. Do proměnné phong.vao zapište id vertex arrays objektu. Data vertexů naleznete v proměnné <a class="el" href="model_8h.html" title="This file contains a 3D model in static arrays. ">model.h</a>/modelVertices - ty překopírujte do bufferu phong.vbo. Data indexů naleznete v proměnné <a class="el" href="model_8h.html" title="This file contains a 3D model in static arrays. ">model.h</a>/modelIndices - ty překopírujte do bufferu phong.ebo. Dejte si pozor, abyste správně nastavili stride a offset Vrchol králička je složen ze dvou vertex atributů: pozice a normála. Prozatím zkuste pouze nahrát pozice vertexů Použijte DSA přístup, viz upozornění v závorkách níže <b>Seznam funkcí, které jistě využijete:</b><ul>
<li>glCreateBuffers (namísto starého glGenBuffers)</li>
<li>glNamedBufferData (namísto starého glBufferData a glBindBuffer)</li>
<li>glCreateVertexArrays (namísto starého glGenVertexArrays)</li>
<li>glVertexArrayElementBuffer</li>
<li>glVertexArrayVertexBuffer (namísto starého glGetAttribLocation a glVertexAttribPointer)</li>
<li>glEnableVertexArrayAttrib</li>
<li>glBindVertexArray </li>
</ul>
</dd></dl>
<dl class="todo"><dt><b><a class="el" href="todo.html#_todo000008">Todo:</a></b></dt><dd>1.2.) Doprogramujte kreslící funkci <a class="el" href="student_8h.html#a53ffbb1a271d285abdaf7a029192f47e" title="This function is called every frame and is responsible for drawing. ">phong_onDraw()</a>. Zde byste měli aktivovat vao a spustit kreslení. Funcke glDrawElements kreslí indexovaně, vyžaduje 4 parametry: mode - typ primitia, počet indexů, typ indexů (velikost indexu), a offset. Kreslíte trojúhelníky, počet vrcholů odpovídá počtu indexů viz proměnná <a class="el" href="model_8h.html" title="This file contains a 3D model in static arrays. ">model.h</a>/modelIndices.<br />
 <b>Seznam funkcí, které jistě využijete:</b> (- glBindVertexArray)<ul>
<li>glDrawElements </li>
</ul>
</dd></dl>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Apr 24 2019 08:37:08 for Izg 2018 - 2019, lab 6. by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.9.1
</small></address>
</body>
</html>
